<script setup lang="ts">
  import { ParticipantState, OrderCustomer } from 'logic/interfaces';
  import { formatDate } from '~/helpers';
  import { Sidebar } from '~/components/presentation/model';

  const props = defineProps<{
    participant: ParticipantState;
    controller: ReturnType<typeof useModal>;
  }>();
  const attendeeId = computed(() => props.participant.attendeeId);

  const { getFormattedPrice } = usePrice();
  const { setControlledClient } = useParticipants();
  const rightSidebarController = useRightSidebar();
  const loading = ref(false);

  const {
    loadCustomerData,
    loadCustomerOrdersStatistics,
    loadCustomerOrders,
    insightsData,
    customerLikesCount,
    loadCustomerInsights,
    orders,
    lastYear,
    currentYear,
    currentYearOrdersTotalPrice,
    lastYearOrdersTotalPrice,
  } = useCustomerInsights(attendeeId);

  onBeforeMount(async () => {
    loading.value = true;
    await loadCustomerData();
    await Promise.all([
      loadCustomerInsights(),
      loadCustomerOrdersStatistics(),
      loadCustomerOrders(),
    ]);
    loading.value = false;
  });

  // const handleChangeCurrentPage = (page: number) => {
  //   loadCustomerOrders(page);
  // };

  const cartCount = computed(() => {
    return insightsData?.value?.productCount || 0;
  });

  const wishlistCount = computed(() => {
    return customerLikesCount.value || 0;
  });

  // const searchValue = ref();

  // const onSearchChanged = (val: string) => {
  //   const temp = val.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
  //   searchValue.value = temp;
  //   console.log('Searching...');
  // };

  const viewShoppingCart = () => {
    setControlledClient(attendeeId.value);
    rightSidebarController.toggle(Sidebar.CART);
    props.controller.close();
  };

  // const openOrderDetail = (order: OrderCustomer) => {
  //   // TODO: open order detail page
  //   console.log('detail', order);
  //   // await router.push('/account/order');
  //   // props.controller.close();
  // };

  const viewLikeList = () => {
    setControlledClient(attendeeId.value);
    rightSidebarController.toggle(Sidebar.LIKE_LIST);
    props.controller.close();
  };
</script>

<template>
  <SwModal :controller="props.controller" panel-class="min-w-[45rem]">
    <template #header>
      <div
        class="border-b-1 bg-background-raised border-border z-50 flex items-center justify-between rounded-t-none border-0 px-6 py-4 md:rounded-t-md"
      >
        <div class="flex flex-col">
          <h3 class="text-lg/[1.625rem] font-bold capitalize tracking-[0.01125rem]">
            {{ participant.attendeeName }}
          </h3>
          <span class="text-(information-subdued xs) font-medium">
            {{ $t('presentation.participants.participantStatistics') }}
          </span>
        </div>

        <button
          type="button"
          class="text-information hover:bg-interactive-hover active:bg-interactive-pressed rounded-md bg-transparent p-2 outline-none"
          @click="props.controller.close"
        >
          <span class="sr-only">{{ $t('close') }}</span>
          <span class="i-sw-regular:times-xs" />
        </button>
      </div>
    </template>
    <template #body>
      <SwLoading v-if="loading" class="text-primary z-loading absolute inset-0 bg-white text-3xl" />
      <div v-else class="flex flex-col space-y-6">
        <div>
          <p class="mb-4 font-bold">{{ $t('presentation.participants.currentSession') }}</p>
          <div class="flex flex-row space-x-8">
            <!-- TODO: api not return the likelist data for now -->
            <div class="flex flex-1 flex-col">
              <span class="text-(information-subdued xs) font-medium">
                {{ $t('wishlist.header') }}
              </span>
              <span class="pt-1 font-semibold">
                {{
                  `${wishlistCount} ${
                    wishlistCount >= 2 ? $t('product.products') : $t('product.product')
                  }`
                }}
              </span>
              <SwButton variant="action" class="mt-3 w-fit" @click="viewLikeList">
                {{ $t('presentation.participants.viewWishlist') }}
                <span class="i-sw-solid:long-arrow-right pl-1.5 text-sm/none"></span>
              </SwButton>
            </div>
            <div class="flex flex-1 flex-col">
              <span class="text-(information-subdued xs) font-medium">{{ $t('cart.header') }}</span>
              <span class="pt-1 font-semibold">
                {{
                  `${cartCount} ${
                    cartCount >= 2 ? $t('product.products') : $t('product.product')
                  } (${getFormattedPrice(insightsData?.cartSum ?? 0)})`
                }}
              </span>
              <SwButton variant="action" class="mt-3 w-fit" @click="viewShoppingCart">
                {{ $t('presentation.participants.viewShoppingCart') }}
                <span class="i-sw-solid:long-arrow-right pl-1.5 text-sm/none"></span>
              </SwButton>
            </div>
          </div>
        </div>
        <div class="border-(border b)" />
        <div>
          <p class="mb-4 font-bold">{{ $t('presentation.participants.turnover') }}</p>
          <div class="flex flex-row space-x-8">
            <div class="flex flex-1 flex-col">
              <span class="text-(information-subdued xs) font-medium">
                {{ $t('presentation.participants.turnover') }} {{ currentYear }}
              </span>
              <span class="pt-1 font-semibold">
                {{ getFormattedPrice(currentYearOrdersTotalPrice, true) }}
              </span>
            </div>
            <div class="flex flex-1 flex-col">
              <span class="text-(information-subdued xs) font-medium">
                {{ $t('presentation.participants.turnover') }} {{ lastYear }}
              </span>
              <span class="pt-1 font-semibold">
                {{ getFormattedPrice(lastYearOrdersTotalPrice, true) }}
              </span>
            </div>
          </div>
        </div>
        <div class="border-(border b)" />
        <div class="flex flex-col space-y-3">
          <div class="flex flex-row space-x-8">
            <span class="flex-1 font-bold">{{ $t('account.orderHistoryHeader') }}</span>
            <!-- TODO: api can not search for now -->
            <!-- <SwSearchInput class="flex-1" @change="onSearchChanged" /> -->
          </div>
          <template v-if="orders.length">
            <div class="table w-full table-fixed text-sm">
              <div class="table-row-group">
                <div v-for="(order, index) of orders" :key="index" class="table-row">
                  <div class="border-border table-cell truncate border-b py-4">
                    <span class="">
                      {{ $t('breadcrumbs.order') }} #{{ order.order?.orderNumber }}</span
                    >
                  </div>
                  <div
                    class="border-border text-information-subdued table-cell border-b px-5 py-4 text-right"
                  >
                    <span> {{ getFormattedPrice(order.order?.amountTotal || 0, true) }} </span>
                  </div>
                  <div class="border-border text-information-subdued table-cell border-b px-5 py-4">
                    <span>
                      {{ formatDate(order.order?.orderDate) }}
                    </span>
                  </div>
                  <!-- TODO: expanded order detail later -->
                  <!-- <div class="border-border table-cell border-b py-4 text-right">
                    <div>
                      <SwButton variant="action" @click="openOrderDetail(order)">
                        {{ $t('openOnPage') }}
                        <span class="i-sw-solid:external-link-s pl-1.5 text-xs/none" />
                      </SwButton>
                    </div>
                  </div> -->
                </div>
              </div>
            </div>
            <!-- TODO: api is return all orders now * -->
            <!-- <div class="flex flex-row items-center justify-between">
              <SwPagination
                :page-size="1"
                :total="21"
                :around-items="1"
                @update:model-value="handleChangeCurrentPage"
              />
              <span class="text-(xs information)">
                {{ $t('presentation.participants.paginationText', { from: 1, to: 5, total: 78 }) }}
              </span>
            </div> -->
          </template>
          <div v-else>
            {{ $t('account.noOrdersYet') }}
          </div>
        </div>
        <!-- TODO: create a task with price * -->
        <span class="text-(information-subdued xs) font-medium">
          {{ `${$t('star')}${$t('product.includeTaxInfo')}` }}
        </span>
      </div>
    </template>
    <template #footer>
      <SwButton variant="action" @click="props.controller.close">{{ $t('close') }}</SwButton>
    </template>
  </SwModal>
</template>
